#include <string.h>
#include "work1.h"

/////////////////////////////////////////////////////////////////////////////
// ॠ  Storage

//---------------------------------------------------------------------------
Storage::~Storage()
  {
    delete st;       // 㤠塞 ᨢ char
  }

//---------------------------------------------------------------------------
void Storage::clear()
  {
    cur_pos = 0;
  }

//---------------------------------------------------------------------------
char *Storage::insert(const char *s)
  {
    // 頥 㪠⥫  ⠢ ப
    // 0  㤠

    int l = strlen(s) + 1;   //  ப + '\0'
    if (cur_pos + l >= len)  // ᫨ ⥪騩 ᨢ ,  㤠
      return 0;

    char *res = st + cur_pos; // १騩  ப
    strcpy(res, s);           // 㥬
    cur_pos += l;             // ᤢ ⥪ 
    return res;
  }

/////////////////////////////////////////////////////////////////////////////
// ॠ  Tab

//---------------------------------------------------------------------------
Tab::Tab(unsigned n, Storage *s):
  size(n), st(s), tab(new Node(new Name[n], 0))
  {
    tab->next = tab;
  }

//---------------------------------------------------------------------------
Tab::~Tab()
  {
/*    Node *node = tab->next;
    tab->next = 0;
    while (node)
      {
        tab = node;
        node = node->next;
        delete tab;
      }
    delete st;  // 㤠塞 Storage
  */

  }

//---------------------------------------------------------------------------
int Tab::lookup(Node *node, const char *s, int *pos) const
  {

    int lpos = 0, rpos = node->len, res;
    while (*pos = (rpos - lpos) >> 1)
      if ((res = strcmp(s, node->names[lpos + *pos].key)) > 0) lpos += *pos;
        else if (res < 0) rpos -= *pos;
          else break;

    *pos += lpos;
    return node->len ? strcmp(s, node->names[*pos].key): -1;
  }

//---------------------------------------------------------------------------
Name *Tab::remove(Node *node, const char *s)
  {
    int i, res = lookup(node, s, &i);
    if (!res)
      {
        int pos = node->free_pos;
        while (pos >= 0)
          {
            if (!strcmp(s, node->names[pos].key))
              return 0;
            pos = node->names[pos].count;
          }

        node->names[i].count = node->free_pos;
        node->free_pos = i;
        return node->names + i;
      }

    return 0;
  }

//---------------------------------------------------------------------------
Name *Tab::insert(Node *node, const char *s)
  {
    int i, res = lookup(node, s, &i);
    if (res)
      {
        if (node->len >= size)
          if (node->free_pos < 0) return 0;
          else optimize(node);
        node->len++;

        const char *loc = st->insert(s);
        if (!loc) return 0;

        if (res > 0) i++;

        for (int j = node->len; j > i; j--)
          node->names[j] = node->names[j - 1];

        node->names[i].key = loc;
        node->names[i].count = 1;

        if (node->free_pos >= i) node->free_pos++;
        int pos = node->free_pos;
        while (pos >= 0)
          {
            unsigned &c = node->names[pos].count;
            if (c >= i) c++;
            pos = c;
          }

        return node->names + i;

      }

    return 0;
  }

//---------------------------------------------------------------------------
void Tab::optimize(Node *node)
  {
    int i, pos;
    while (node->free_pos >= 0)
      {
        pos = i = node->free_pos;
        node->free_pos = node->names[i].count;

        node->len--;
        while (i++ < node->len)
          node->names[i - 1] = node->names[i];

        i = pos;
        if (node->free_pos >= i) node->free_pos--;
        pos = node->free_pos;
        while (pos >= 0)
          {
            unsigned &c = node->names[pos].count;
            if (c >= i) c--;
            pos = c;
          }

      }

    node->free_pos = -1;

  }

//---------------------------------------------------------------------------
Name *Tab::insert(const char *s)
  {
    // 頥 㪠⥫  ⠢  Name
    // 0  㤠

    Node *node = tab, *prev;
    Name *res;
    do
      {
        if (node->len < size || node->free_pos >= 0)
          return insert(node, s);
        prev = node;
        node = node->next;
      }
    while (node != tab);

    tab = new Node(new Name[size], tab);
    prev->next = tab;
    return insert(tab, s);
  }

//---------------------------------------------------------------------------
Name *Tab::lookup(const char *s) const
  {
    // 頥 㪠⥫  Name, 0  㤠

    int pos;
    Node *node = tab;
    do
      {
        if (!lookup(node, s, &pos))
          return node->names + pos;
        node = node->next;
      }
    while (node != tab);

    return 0;
  }

//---------------------------------------------------------------------------
Name *Tab::remove(const char *s)
  {
    // 頥 㪠⥫   Name
    // 0  㤠
    Node *node = tab;
    Name *res;
    do
      {
        if (res = remove(node, s))
          return res;
        node = node->next;
      }
    while (node != tab);

    return 0;

  }

//---------------------------------------------------------------------------
void Tab::clear()
  {
    // 頥 ⠡
    Node *node = tab;
    do
      {
        node->len = 0;
        node->free_pos = -1;
        node = node->next;
      }
    while (node != tab);

    st->clear(); // 頥   ப 
  }

//---------------------------------------------------------------------------
void Tab::print(ostream &out)
  {
    // 㭪 뢮 ⠡  ⮪

    Node *node = tab;
    do
      {
        optimize(node);
        for (unsigned i = 0; i < node->len; i++) // 室  ᥬ ⠬
          out << node->names[i]; // 뢮 
        node = node->next;
      }
    while (node != tab);

  }
