#ifndef _WORK1_H
#define _WORK1_H

#include <iostream.h>

/////////////////////////////////////////////////////////////////////////////
class Storage
  {
    // ।祭  ࠭ ப ᨬ  ୮ ᨢ

    public:
      Storage(unsigned size);
      ~Storage();

      char *insert(const char *s);
      void clear();

    private:
      char *st;
      const unsigned len;
      unsigned cur_pos;

  };

//---------------------------------------------------------------------------
inline Storage::Storage(unsigned size): // size > 0 !!!
  len(size), cur_pos(0), st(new char[size])
  {
  }


/////////////////////////////////////////////////////////////////////////////
class Name
  {
    //  ⠡ 

    public:
      Name();
      void print(ostream &out) const;

      const char *key;
      unsigned count;
  };

//---------------------------------------------------------------------------
inline Name::Name():
  key(0), count(-1) {}

//---------------------------------------------------------------------------
inline void Name::print(ostream &out) const
  {
    // 㭪 뢮  ⮪

    out << key << "\t\t" << count << endl;
  }

//---------------------------------------------------------------------------
inline ostream & operator << (ostream &out, const Name n)
  {
    n.print(out);
    return out;
  }

/////////////////////////////////////////////////////////////////////////////
class Node
  {
    // ࠡ稩   ࣠樨 ᯨ᪠
    // ᯮ Tab

    private:
      Node(Name *n, Node *p);
      ~Node();

      Node *next;
      Name *names;
      int len;
      int free_pos;

      friend class Tab;
  };

//---------------------------------------------------------------------------
inline Node::Node(Name *n, Node *p):
  names(n), next(p), len(0), free_pos(-1) {}

//---------------------------------------------------------------------------
inline Node::~Node()
  {
    delete [] names;
  }

/////////////////////////////////////////////////////////////////////////////
class Tab
  {
    // ࠢ 楢 ᯨ᮪  ᨢ

    public:
      Tab(unsigned n, Storage *s);
      ~Tab();

      Name *insert(const char *s);
      Name *lookup(const char *s) const;
      Name *remove(const char *s);
      void clear();

      void print(ostream &out);

    private:
      int lookup(Node *node, const char *s, int *pos) const;
      Name *remove(Node *node, const char *s);
      Name *insert(Node *node, const char *s);
      void optimize(Node *node);
      const unsigned size;
      Node *tab;
      Storage *st;

  };

//---------------------------------------------------------------------------
inline ostream & operator << (ostream &out, Tab &tab)
  {
    tab.print(out);
    return out;
  }


#endif // #ifndef _WORK1_H