

/*-------------------------------------------------------------*/
/*  main_t.h */
/*-------------------------------------------------------------*/

typedef enum {
    LETTER = 1, DIG, ERS, BTFN, IGN, NO_SIC
} sic_type;

typedef enum {
  NO_LC = 0,
  ADD, ASS, CL,  COM, DIV, DVT, EQ,  ENF, ERL, FLT, 
  GE,  GT,  ID,  IGNORE,   INT,
  LE,  LRB, LSB, LT,  MOD, MUL, NE,  PCL, PNT, RRB, RSB,
  SPACE,    STRELA,   SUB,
  KWABORT, KWBEGIN, KWCASE,  KWEND, KWFLOAT, KWINT,   KWLOOP,
  KWOR,    KWREAD,  KWSKIP,  KWSPACE, KWTAB, KWVAR,   KWWRITE
} lc_type;

//  , 室  ࠡ  ⠡楩 
typedef enum {INTTYP, FLOATTYP} scalType;

struct application {
  scalType typ; // ᪠ ⨯  ⠡
  int  len; //   ( = 0, ᫨ ᪠)
  int addr; //   䨧᪮  (⮫쪮 ᪮)
};

struct element {
  char* name;
  struct application appl;
};

struct node {
  struct element val;
  struct node *next;
};

//    㭪樨, ᯥ稢騥 ࠭  ࠡ ࠭

// ࣠ ⠭
struct CONST {
  scalType typ; // ⨯ ⠭
  union {
    int   unum;  // 楫 ⠭
    float fnum;  // ⢨⥫쭠 ⠭
  } val; // 祭 ⠭
};

//     ⠭
struct CONST *CONST_constructor(scalType, void*);

//  ࠭
typedef enum {
  nameVarOpd, //  ६  ⠡ 
  tmpVarOpd,  // ஬筠 ६  ࠦ
  constOpd,   // ⠭ ࠭
  labelOpd    // ࠭ - ⪠
} opdType;

// ࣠ ࠭
struct OPERAND {
  opdType typ; // ⨯ ࠭
  union {
    // 뫪    ஬ ६
    struct application *var;
    // 뫪  ⠭
    struct CONST *cons;
    // 뫪  
    struct INSTRUCTION *label;
  } val; // 祭 ࠭
  // ⥫ ࠬ, ᯥ稢騥 ஢
  int ident; // 㭨 䨪 ࠭
  struct OPERAND *next; //  ࣠樨 ᯨ᪠ ࠭
};

//     ࠭
struct OPERAND* OPERAND_constructor(opdType, void*);

// ࣠ ᯨ᪠ ࠭
struct OPD_LIST {
  struct OPERAND *last;
};

//  ࠭  ᯨ ࠭
void OPD_LIST_append(struct OPD_LIST*, struct OPERAND*);

// 뢮 ᯨ᪠ ࠭  䠩
void OPD_LIST_out(struct OPD_LIST*, FILE*);

//    㭪樨, ᯥ稢騥 ࠭  ࠡ
//  ஬筮 ।⠢

//   ஬筮 ।⠢
typedef enum {
  addOpc,	assOpc,		divOpc,		eqOpc,
  emptyOpc,     exitOpc,	geOpc,		gotoOpc,
  gtOpc,
  ifOpc,	inOpc,		indexOpc,	labelOpc,
  leOpc,	ltOpc,		minOpc,         modOpc,
  multOpc,	neOpc,          outOpc,		skipOutOpc,
  spaceOutOpc,  subOpc,         tabOutOpc
} opcType;

// ࣠ ஬筮 
struct INSTRUCTION {
  opcType opc;
  struct INSTRUCTION *next; // ⭮襭 ᯮ/ࠢ
  // ࠭  樨
  struct OPERAND *arg1;
  struct OPERAND *arg2;
  struct OPERAND *rez;
  //    ⥪ ணࠬ
  int line;
  int column;
};

//     
struct INSTRUCTION* INSTRUCTION_constructor
   (opcType, struct OPERAND*, struct OPERAND*, struct OPERAND*);

// ࣠ ᯨ᪠ ஬ 
struct INSTR_LIST {
  struct INSTRUCTION *firstInstr;
  struct INSTRUCTION *lastInstr;
  struct OPERAND* lastOpd;
};

//     ᯨ᪠  ஬筮 ।⠢
struct INSTR_LIST *INSTR_LIST_constructor(struct INSTRUCTION*,
   struct INSTRUCTION*, struct OPERAND*);

// ⥭  ᯨ᪮   
//   ⠭ ࠭ ᯨ᪠  ந.
//   ⢫   ணࠬ 
void INSTR_LIST_cat(struct INSTR_LIST**, struct INSTR_LIST*);

//   ᯨ  ⤥쭮 
void INSTR_LIST_append(struct INSTR_LIST**, struct INSTRUCTION*);

// 뢮 ᯨ᪠ 
void INSTR_LIST_out(struct INSTR_LIST *, FILE*);

//  ࠭ - ⪨
struct OPERAND* CreateLabel(void);
