 // Name: assign.c
 // 09.09.96

 #include <assert.h>

 #include "crush.h"

 void assign(int i)
   {
     Operand opd;
     Temp *index;
     Ident ident;
     Temp *temp;
     Const c;
     int   num, code;
     char *l_val, *r_val;
     int   l_len = 0, r_len = 0, size;

     opd = oper_tab[instr_tab[i].arg1]; // ࠢ ࠭ 樨 assign

     switch (opd.type)
       {
         case nameVarOpd:
           ident = ident_tab[opd.val.ident_num];
           r_val = &mem[ident.addr];
           r_len = ident.len;
           code  = r_scal_code(ident.type);
           break;

         case tmpVarOpd:
           if (temp = get_temp(opd.val.temp_num))
             {
               r_val = &stack[temp->addr];
               r_len = temp->len;
               code  = r_scal_code(temp->type);
               free(temp);
             }
           else error("Invalid operands combination");
           break;

         case indexVarOpd:
           if (index = get_index(opd.val.temp_num))
             {
               r_val = &mem[index->addr];
               r_len = index->len;
               code  = r_scal_code(index->type);
               free(index);
             }
           else error("Invalid index operands combination");
           break;

         case constOpd:
           c     = const_tab[opd.val.const_num];
           r_val = &c.val;
           code  = r_scal_code(c.type);
           break;

         default:
           error("Invalid right operand in assign instruction");

       } // switch (opd.type)

     opd = oper_tab[instr_tab[i].arg2]; //  ࠭ 樨 assign

     switch (opd.type)
       {
         case nameVarOpd:
           ident = ident_tab[opd.val.ident_num];
           l_val = &mem[ident.addr];
           l_len = ident.len;
           code |= l_scal_code(ident.type);
           break;

         case tmpVarOpd:
           temp = malloc(sizeof(Temp));
           assert(temp);
           temp->next = 0;
           temp->prev = 0;
           temp->id   = opd.val.temp_num;
           temp->addr = stack_top;
           temp->type = r_scal_type(code);
           temp->len  = l_len = r_len;
           ins_temp(temp);

           l_val = &stack[temp->addr];
           code |= l_scal_code(temp->type);

           size = (temp->type == int_type) ? sizeof(int) :
                                             sizeof(float);

           stack_top += l_len ? l_len * size : size;
           if (stack_top >= stack_size)
             error("Too many temporary varibles: stack overflow");

           break;

         case indexVarOpd:
           if (index = get_index(opd.val.temp_num))
             {
               l_val = &mem[index->addr];
               l_len = index->len;
               code |= l_scal_code(index->type);
               free(index);
             }
           else error("Invalid index operands combination");
           break;

         default:
           error("Left operand must be lvalue in assign instruction");

       } // switch (opd.type)

     if (l_len != r_len)
       error("Operands has different length in assignment");

     num = l_len ? l_len : 1;
     switch (code)
       {
         case int_int:
           while (num--)
             *(((int *)l_val)++) = *(((int *)r_val)++);
           break;

         case int_float:
           while (num--)
             *(((int *)l_val)++) = *(((float *)r_val)++);
           break;

         case float_int:
           while (num--)
             *(((float *)l_val)++) = *(((int *)r_val)++);
           break;

         case float_float:
           while (num--)
             *(((float *)l_val)++) = *(((float *)r_val)++);
           break;

         default:
           error("Invalid operand types");
       } // switch (code)

   } // void assign(int i)
