 // Name: help.c
 // 24.09.96

 #include <stdio.h>

 #include "crush.h"

 char *help_str[] =
   {
     "\n********************************* Help ****************************************",
     "*  m<addr1>-[<addr2>] - type memory contens at <addr1> to <addr2>             *",
     "*  s<addr1>[-<addr2>]=<value> - set value to memory at <addr1> to <addr2>     *",
     "*  g[<number>] - start program at current or <number> instruction             *",
     "*  t[<number>] - trace current or <number> instruction                        *",
     "*  d[<number>] - start program at current or <number> instruction and save    *",
     "*                result memory dump                                           *",
     "*  p           - print current instruction                                    *",
     "*  h           - type this help message                                       *",
     "*  q           - quit                                                         *",
     "**************** Attention: command line can`t has space symbols! *************"
   };

 void help(void)
   {
     int i;
     for (i = 0; i < 11; i++)
       puts(help_str[i]);
   }

 void print_instr(int i)
   {
     char *opcName;
     switch(instr_tab[i].opcode)
       {
         case addOpc:       opcName = "ADD";       break;
         case assOpc:       opcName = "ASSIGN";    break;
         case divOpc:       opcName = "DIV";       break;
         case eqOpc:        opcName = "EQ";        break;
         case emptyOpc:     opcName = "EMPTY";     break;
         case exitOpc:      opcName = "EXIT";      break;
         case geOpc:        opcName = "GE";        break;
         case gotoOpc:      opcName = "GOTO";      break;
         case gtOpc:        opcName = "GT";        break;
         case ifOpc:        opcName = "IF";        break;
         case inOpc:        opcName = "IN";        break;
         case indexOpc:     opcName = "INDEX";     break;
         case labelOpc:     opcName = "LABEL";     break;
         case leOpc:        opcName = "LE";        break;
         case ltOpc:        opcName = "LT";        break;
         case minOpc:       opcName = "MIN";       break;
         case modOpc:       opcName = "MOD";       break;
         case multOpc:      opcName = "MULT";      break;
         case neOpc:        opcName = "NE";        break;
         case outOpc:       opcName = "OUT";       break;
         case subOpc:       opcName = "SUB";       break;
         case skipOutOpc:   opcName = "SKIPOUT";   break;
         case spaceOutOpc:  opcName = "SPACEOUT";  break;
         case tabOutOpc:    opcName = "TABOUT";    break;
         default:           opcName = "NODEF";
       } // switch (instr_tab[i].opcode)

     printf("ip = %d  %s %d, %d, %d\n",
      i, opcName, instr_tab[i].arg1, instr_tab[i].arg2, instr_tab[i].rez );

   } // void print_instr(int i);
