 // Name: index.c
 // 09.09.96

 #include <assert.h>

 #include "crush.h"

 void index(int i)
   {
     Operand opd, rez;
     Temp *index;
     Ident ident, array;
     Temp *temp;
     Const c;
     int  *value, size, length = 0;
     scalType type;

     opd = oper_tab[instr_tab[i].arg1]; // 㥬 ࠭
     rez = oper_tab[instr_tab[i].rez];

     array = ident_tab[opd.val.ident_num];
     if (opd.type != nameVarOpd || !array.len)
       error("Operand must be array");


     index = malloc(sizeof(Temp));
     assert(index);
     index->next = 0;
     index->prev = 0;
     index->len  = 0;
     index->id   = rez.val.temp_num;
     index->type = array.type;
     oper_tab[instr_tab[i].rez].type = indexVarOpd;
     ins_index(index);

     opd = oper_tab[instr_tab[i].arg2];
     switch (opd.type)
       {
         case nameVarOpd:
           ident  = ident_tab[opd.val.ident_num];
           type   = ident.type;
           length = ident.len;
           value  = &mem[ident.addr];
           break;

         case tmpVarOpd:
           if (temp = get_temp(opd.val.temp_num))
             {
               type   = temp->type;
               length = temp->len;
               value  = &stack[temp->addr];
               free(temp);
             }
           else error("Invalid operands combination");
           break;

         case indexVarOpd:
           if (index = get_index(opd.val.temp_num))
             {
               type  = index->type;
               value = &mem[index->addr];
               free(index);
             }
           else error("Invalid index operands combination");
           break;

         case constOpd:
           c     = const_tab[opd.val.const_num];
           type  = c.type;
           value = &c.val;
           break;

         default:
           error("Invalid index operand");

       } // switch (opd.type)

     if (length)
       error("Index varible can`t be an array");

     if (type != int_type)
       error("Index varible must be an integer");

     size = (array.type == int_type) ? sizeof(int) :
                                       sizeof(float);

     index->addr = array.addr + *value * size;

   } // void index(int i)
