

/******************************************************************
 instr.c - । 㭪権 ࠡ⪨ 権
******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <errno.h>

#include "main_c.h"
#include "main_t.h"
#include "main_e.h"
#include "transl.h"

void er(int);

//     
struct INSTRUCTION* INSTRUCTION_constructor(opc, arg1, arg2, rez)
  opcType opc;
  struct OPERAND* arg1;
  struct OPERAND* arg2;
  struct OPERAND* rez;
{
  struct INSTRUCTION* iPtr;
  if((iPtr = (struct INSTRUCTION*)malloc(sizeof(struct INSTRUCTION)))==NULL)
  {
    er(23); exit(1);
  }
  iPtr->opc = opc;
  iPtr->arg1 = arg1;
  iPtr->arg2 = arg2;
  iPtr->rez = rez;
  iPtr->next = NULL;
  iPtr->line = line;
  iPtr->column = column;
  return iPtr;
}

//     ᯨ᪠  ஬筮 ।⠢
struct INSTR_LIST *INSTR_LIST_constructor(fInstrPtr, eInstrPtr, opdPtr)
  struct INSTRUCTION *fInstrPtr;
  struct INSTRUCTION *eInstrPtr;
  struct OPERAND *opdPtr;
{
  struct INSTR_LIST *iListPtr;
  if((iListPtr = (struct INSTR_LIST*)malloc(sizeof(struct INSTR_LIST)))==NULL)
  {
    er(23); exit(1);
  }
  iListPtr->firstInstr = fInstrPtr;
  iListPtr->lastInstr = eInstrPtr;
  iListPtr->lastOpd = opdPtr;
  return iListPtr;
}

// ⥭  ᯨ᪮   
//   ⠭ ࠭ ᯨ᪠  ந.
//   ⢫   ணࠬ 
void INSTR_LIST_cat(iListRecPtrPtr, iListSrcPtr)
  struct INSTR_LIST **iListRecPtrPtr;
  struct INSTR_LIST *iListSrcPtr;
{
  // ஢ઠ    ᯨ᪮ 
  if(*iListRecPtrPtr == NULL) // ᮪ ਥ 
    if(iListSrcPtr == NULL) // ᮪ 筨 
      return; // - 稫 ⮩ १
    else { //  筨 
      *iListRecPtrPtr = iListSrcPtr;
      return;
    }
  else // ᮪ ਥ 
    if(iListSrcPtr == NULL) // ᮪ 筨 
      return; // - 稫 १, ࠢ ਥ
  // ⥭ ॠ쭮 ந室  ⮬ 筨
  if(iListSrcPtr->firstInstr != NULL) { // 筨    ᯨ᪮
    if((*iListRecPtrPtr)->firstInstr != NULL) // ਥ -  ⮩ ᯨ᮪
      (*iListRecPtrPtr)->lastInstr->next = iListSrcPtr->firstInstr;
    else
      (*iListRecPtrPtr)->firstInstr = iListSrcPtr->firstInstr;
    (*iListRecPtrPtr)->lastInstr  = iListSrcPtr->lastInstr;
  }
}

//   ᯨ  ⤥쭮 
void INSTR_LIST_append(iListRecPtrPtr, instrPtr)
  struct INSTR_LIST **iListRecPtrPtr;
  struct INSTRUCTION *instrPtr;
{
  // ஢ઠ  ⢨ ᯨ᪠    ନ஢  ⮬ 砥
  if(*iListRecPtrPtr == NULL) {// ᯨ᮪  
    *iListRecPtrPtr = INSTR_LIST_constructor(NULL, NULL, NULL);
    (*iListRecPtrPtr)->firstInstr = instrPtr;
    (*iListRecPtrPtr)->lastInstr = instrPtr;
    return;
  }
  if((*iListRecPtrPtr)->firstInstr != NULL)
    (*iListRecPtrPtr)->lastInstr->next = instrPtr;
  else
    (*iListRecPtrPtr)->firstInstr = instrPtr;
  (*iListRecPtrPtr)->lastInstr = instrPtr;
}

// 뢮 ᯨ᪠ 
void INSTR_LIST_out(struct INSTR_LIST *iListRec, char *name)
{
  struct INSTRUCTION *ptr;
  int handle;
  int i = 0;

  if ((handle = _creat(name, 32)) < 0)
    {
      printf("訡  䠩 %s!\n", name);
      perror("Error");
      return;
    }

  if (!iListRec || !iListRec->firstInstr)
    {
      _close(handle);
      return;
    }

  fprintf(outfile, "\t\t᮪ :\n");
  for (ptr = iListRec->firstInstr; ptr; ptr = ptr->next)
    {
      struct Instr buf;
      char *opcName;
      buf.opcode = ptr->opc;
      buf.arg1   = ptr->arg1   ? ptr->arg1->ident : 0; //-1;
      buf.arg2   = ptr->arg2   ? ptr->arg2->ident : 0; //-1;
      buf.rez    = ptr->rez    ? ptr->rez->ident  : 0; //-1;
      buf.line   = ptr->column ? ptr->line        : ptr->line-1;

      write(handle, &buf, sizeof(buf));

      switch(ptr->opc)
        {
          case addOpc:       opcName = "ADD";       break;
          case assOpc:       opcName = "ASSIGN";    break;
          case divOpc:       opcName = "DIV";       break;
          case eqOpc:        opcName = "EQ";        break;
          case emptyOpc:     opcName = "EMPTY";     break;
          case exitOpc:      opcName = "EXIT";      break;
          case geOpc:        opcName = "GE";        break;
          case gotoOpc:      opcName = "GOTO";      break;
          case gtOpc:        opcName = "GT";        break;
          case ifOpc:        opcName = "IF";        break;
          case inOpc:        opcName = "IN";        break;
	  case indexOpc:     opcName = "INDEX";     break;
          case labelOpc:     opcName = "LABEL";     break;
          case leOpc:        opcName = "LE";        break;
          case ltOpc:        opcName = "LT";        break;
          case minOpc:       opcName = "MIN";       break;
          case modOpc:       opcName = "MOD";       break;
          case multOpc:      opcName = "MULT";      break;
          case neOpc:        opcName = "NE";        break;
          case outOpc:       opcName = "OUT";       break;
          case subOpc:       opcName = "SUB";       break;
          case skipOutOpc:   opcName = "SKIPOUT";   break;
          case spaceOutOpc:  opcName = "SPACEOUT";  break;
          case tabOutOpc:    opcName = "TABOUT";    break;
          default:           opcName = "NODEF";
        } // switch (ptr->opc)

      fprintf(outfile, "%3d %-10s%3d,\t%3d,\t%3d\t// ப %d\n",
      i, opcName, buf.arg1, buf.arg2, buf.rez, buf.line);

      ptr->opc = i++; // ࠭塞  樨 (  樨  )

    } // for (ptr = iListRec->firstInstr; ptr; ptr = ptr->next)

   _close(handle);
}

