 // Name: lt.c
 // 09.09.96

 #include <assert.h>

 #include "crush.h"

 void lt(int i)
   {
     Operand opd, rez_opd;
     Temp *index;
     Ident ident;
     Temp *temp, *rez;
     Const c;
     int  *rez_val, length, code;
     char *l_val, *r_val;

     rez_opd = oper_tab[instr_tab[i].rez];

     if (rez_opd.type != tmpVarOpd)
       error("Invalid rezult operand in compare");

     rez = malloc(sizeof(Temp));
     assert(rez);
     rez->next = 0;
     rez->prev = 0;
     rez->len  = 0;
     rez->id   = rez_opd.val.temp_num;
     rez->addr = stack_top;
     rez->type = int_type;
     ins_temp(rez);

     stack_top += sizeof(int);
     if (stack_top >= stack_size)
       error("Too many temporary varibles: stack overflow");

     rez_val = (int *)&stack[rez->addr];

     opd = oper_tab[instr_tab[i].arg1]; //  ࠭

     switch (opd.type)
       {
         case nameVarOpd:
           ident  = ident_tab[opd.val.ident_num];
           l_val  = &mem[ident.addr];
           length = ident.len;
           code   = l_scal_code(ident.type);
           break;

         case tmpVarOpd:
           if (temp = get_temp(opd.val.temp_num))
             {
               l_val  = &stack[temp->addr];
               length = temp->len;
               code   = l_scal_code(temp->type);
               free(temp);
             }
           else error("Invalid operands combination");
           break;

         case indexVarOpd:
           if (index = get_index(opd.val.temp_num))
             {
               l_val  = &mem[index->addr];
               length = index->len;
               code   = l_scal_code(index->type);
               free(index);
             }
           else error("Invalid index operands combination");
           break;

         case constOpd:
           c      = const_tab[opd.val.const_num];
           l_val  = &c.val;
           length = 0;
           code   = l_scal_code(c.type);
           break;

         default:
           error("Invalid operand in compare");

       } // switch (opd.type)

     if (length)
       error("Operand can`t be an array");

     opd = oper_tab[instr_tab[i].arg2]; // ࠢ ࠭
     switch (opd.type)
       {
         case nameVarOpd:
           ident  = ident_tab[opd.val.ident_num];
           r_val  = &mem[ident.addr];
           length = ident.len;
           code  |= r_scal_code(ident.type);
           break;

         case tmpVarOpd:
           if (temp = get_temp(opd.val.temp_num))
             {
               r_val  = &stack[temp->addr];
               length = temp->len;
               code  |= r_scal_code(temp->type);
               free(temp);
             }
           else error("Invalid operandes combination");
           break;

         case indexVarOpd:
           if (index = get_index(opd.val.temp_num))
             {
               r_val  = &mem[index->addr];
               length = index->len;
               code  |= r_scal_code(index->type);
               free(index);
             }
           else error("Invalid index operands combination");
           break;

         case constOpd:
           c      = const_tab[opd.val.const_num];
           r_val  = &c.val;
           length = 0;
           code  |= r_scal_code(c.type);
           break;

         default:
           error("Invalid operand in compare");

       } // switch (opd.type)

     if (length)
       error("Operand can`t be an array");

     switch (code)
       {
         case int_int:
           *rez_val = *(int *)l_val < *(int *)r_val;
           break;

         case int_float:
           *rez_val = *(int *)l_val < *(float *)r_val;
           break;

         case float_int:
           *rez_val = *(float *)l_val < *(int *)r_val;
           break;

         case float_float:
           *rez_val = *(float *)l_val < *(float *)r_val;
           break;

         default:
           error("Invalid operand types");
       } // switch (code)

   } // void lt(int i)
