 // Name: neg.c
 // 09.09.96

 #include <assert.h>

 #include "crush.h"

 void neg(int i)
   {
     Operand opd, rez_opd;
     Temp *index;
     Ident ident;
     Temp *temp, *rez;
     Const c;
     int  length = 0, size;
     char *rez_val, *value;

     rez_opd = oper_tab[instr_tab[i].rez];

     if (rez_opd.type != tmpVarOpd)
       error("Invalid rezult operand");

     rez = malloc(sizeof(Temp));
     assert(rez);
     rez->next = 0;
     rez->prev = 0;
     rez->len  = 0;
     rez->id   = rez_opd.val.temp_num;
     rez->addr = stack_top;
     ins_temp(rez);

     rez_val = (int *)&stack[rez->addr];

     opd = oper_tab[instr_tab[i].arg1];

     switch (opd.type)
       {
         case nameVarOpd:
           ident     = ident_tab[opd.val.ident_num];
           value     = &mem[ident.addr];
           length    = ident.len;
           rez->type = ident.type;
           break;

         case tmpVarOpd:
           if (temp = get_temp(opd.val.temp_num))
             {
               value     = &stack[temp->addr];
               length    = temp->len;
               rez->type = temp->type;
               free(temp);
             }
           else error("Invalid operands combination");
           break;

         case indexVarOpd:
           if (index = get_index(opd.val.temp_num))
             {
               value     = &mem[index->addr];
               length    = index->len;
               rez->type = index->type;
               free(index);
             }
           else error("Invalid index operands combination");
           break;

         case constOpd:
           c         = const_tab[opd.val.const_num];
           value     = &c.val;
           rez->type = c.type;
           break;

         default:
           error("Invalid operand");

       } // switch (opd.type)

     if (length)
       error("Operand can`t be an array");

     switch (rez->type)
       {
         case int_type:
           *(int *)rez_val = -*(int *)value;
           size = sizeof(int);
           break;

         case float_type:
           *(float *)rez_val = -*(float *)value;
           size = sizeof(float);
           break;

         default:
           error("Invalid operand types");

       } // switch (rez->type)

     stack_top += size;
     if (stack_top >= stack_size)
       error("Too many temporary varibles: stack overflow");

   } // void neg(int i)
