 // Name: output.c
 // 09.09.96

 #include <assert.h>

 #include "crush.h"

 void output(int i)
   {
     Operand opd;
     Temp *index;
     Ident ident;
     Temp *temp;
     Const c;
     int   length = 0;
     char *value;
     scalType type;

     opd = oper_tab[instr_tab[i].arg1];
     switch (opd.type)
       {
         case nameVarOpd:
           ident  = ident_tab[opd.val.ident_num];
           length = ident.len;
           type   = ident.type;
           value  = &mem[ident.addr];
           break;

         case tmpVarOpd:
           if (temp = get_temp(opd.val.temp_num))
             {
               length = temp->len;
               type   = temp->type;
               value  = &stack[temp->addr];
               free(temp);
             }
           else error("Invalid operands combination");
           break;

         case indexVarOpd:
           if (index = get_index(opd.val.temp_num))
             {
               type  = index->type;
               value = &mem[index->addr];
               free(index);
             }
           else error("Invalid index operands combination");
           break;

         case constOpd:
           c     = const_tab[opd.val.const_num];
           type  = c.type;
           value = &c.val;
           break;

       } // switch (opd.type)

     if (length)
       error("Varible in operator 'write' can`t be an array");

     if (type == int_type) printf("%d", *(int *)value);
		      else printf("%f", *(float *)value);

   } // void output(int i)
