 // Name: str2num.c
 // 09.09.96

 #include <ctype.h>
 #include <math.h>

 //--------------------------------------------------------------------------

 int str2int(char *str, int *rez_ptr)
   {
     char sign = 0;
     int  rez  = 0;
     while (isspace(*str)) str++;

     switch (*str)
       {
         case '-':
           sign = 1;
         case '+':
           str++;
       }

     if (!isdigit(*str)) return 0;
     do
       {
         rez *= 10;
         rez += *str++ -'0';
       }
     while (isdigit(*str));

     if (isspace(*str) || !*str)
       {
         *rez_ptr = sign ? -rez: rez;
         return 1;
       }

     return 0;

   } // str2int(char *str, int *rez_ptr)

 //--------------------------------------------------------------------------

 int str2uns(char **str, int *rez)
   {
     if (!**str) return 1;

     if (!isdigit(**str)) return 0;
     *rez = 0;
     do
       {
         *rez *= 10;
         *rez += *(*str)++ -'0';
       }
     while (isdigit(**str));

     return 1;

   } // int str2uns(char **str, int *rez)

 //--------------------------------------------------------------------------

 int str2float(char *str, float *rez_ptr)
   {
     char  sign = 0;
     float rez  = 0;
     int   pow  = 0;
     long  i = 1;
     while (isspace(*str)) str++;

     switch (*str)
       {
         case '-':
           sign = 1;
         case '+':
           str++;
       }

     if (isdigit(*str))
       {
         i = 0;
         do
           {
             rez *= 10;
             rez += *str++ -'0';
           }
         while (isdigit(*str));
       }

     if (*str == '.') str++;

     if (isdigit(*str))
       {
         i = 10;
         do
           {
             rez += (float)(*str++ -'0')/i;
             i *= 10;
           }
         while (isdigit(*str));
       }
     else if (i) return 0;

     if (toupper(*str) == 'E')
       {
         if (!isdigit(*++str))
           return 0;

         do
           {
             pow *= 10;
             pow += *str++ -'0';
           }
         while (isdigit(*str));

         rez *= pow10(pow);
       }

     if (isspace(*str) || !*str)
       {
         *rez_ptr = sign ? -rez: rez;
         return 1;
       }

     return 0;

   } // str2float(char *str, float *rez_ptr)
