 // Name: trace.c
 // 24.09.96

 #include "crush.h"

 int trace(int i)
   {
     switch (instr_tab[i].opcode)
       {
         Operand l_opd, r_opd;
         Temp *temp;

         //---------------------- addition ------------------------------
         case addOpc:
           addition(i);
           break;

         //--------------------- assignment -----------------------------
         case assOpc:
           assign(i);
           break;

         //---------------------- division ------------------------------
         case divOpc:
           divide(i);
           break;

         //---------------------- equalent ------------------------------
         case eqOpc:
           eq(i);
           break;

         //-------------------- no operation ----------------------------
         case emptyOpc:
           break;

         //------------------------ exit --------------------------------
         case exitOpc:
           return instr_num;

         //------------------ greate or equalent ------------------------
         case geOpc:
           ge(i);
           break;

         //----------------------- go to --------------------------------
         case gotoOpc:
           l_opd = oper_tab[instr_tab[i].arg1];
           if (l_opd.type != labelOpd)
           error("Invalid operand type in instruction");
           return l_opd.val.instr_num;

         //----------------------- greate -------------------------------
         case gtOpc:
           gt(i);
           break;

         //------------------------- if ---------------------------------
         case ifOpc:
           l_opd = oper_tab[instr_tab[i].arg1];
           r_opd = oper_tab[instr_tab[i].arg2];

           if (l_opd.type != tmpVarOpd || r_opd.type != labelOpd)
           error("Invalid operand type in instruction");
           if (temp = get_temp(l_opd.val.temp_num))
           {
             if (temp->type != int_type || temp->len)
               error("Invalid varible type");
             if (!*(int *)&stack[temp->addr])
               return r_opd.val.instr_num;
             free(temp);
           }
           else error("Invalid operands combination");
           break;

         //------------------------ input -------------------------------
         case inOpc:
           input(i);
           break;

         //--------------------- indexation -----------------------------
         case indexOpc:
           index(i);
           break;

         //------------------------ label -------------------------------
         case labelOpc:
           break;

         //------------------ less or equalent --------------------------
         case leOpc:
           le(i);
           break;

         //------------------------- less -------------------------------
         case ltOpc:
           lt(i);
           break;

         //----------------------- negative -----------------------------
         case minOpc:
           neg(i);
           break;

         //--------------------------------------------------------------
         case modOpc:
           mod(i);
           break;

         //--------------------- multiplication -------------------------
         case multOpc:
           multiple(i);
           break;

         //---------------------- not equalent --------------------------
         case neOpc:
           ne(i);
           break;

         //------------------------ output ------------------------------
         case outOpc:
           output(i);
           break;

         //---------------------- substruction --------------------------
         case subOpc:
           substr(i);
           break;

	 //------------------ output space symbol ----------------------
	 case spaceOutOpc:
	   symout(i, ' ');
	   break;

	 //------------------ output new line symbol ----------------------
	 case skipOutOpc:
	   symout(i, '\n');
	   break;

	 //------------------- output tabulations -----------------------
	 case tabOutOpc:
	   symout(i, '\t');
           break;

         //--------------------------------------------------------------
         default:
           error("Invalid code operation");

       } // switch (instr_table[i].opcode)

     return i + 1;

   } // int trace(int i)
