
// Name: COMPIL.C
// 21.09.96


#include <assert.h>
#include <fcntl.h>
#include <io.h>
#include <string.h>
#include <values.h>

#include "compil.h"

// ६
 char flag_stdio, flag_stdlib, flag_float;
 char *name;
 char *exts[] = { ".ins", ".nam", ".opd", ".cnt" };
 FILE *out, *tmp;

 Instr   *instr_tab;
 int     instr_num;

 Ident   *ident_tab;
 int     ident_num;

 Operand *oper_tab;
 int     oper_num;

 Const   *const_tab;
 int     const_num;

//㧪   ⠡ ஬筮 
long load_table(char *name, char **table)
  {
   int handle, i;
   long len;
    if ((handle = _open(name, O_RDONLY)) < 0)
     {
      printf("訡  䠩 '%s' !\n", name);
      abort();
     }
    len = filelength(handle);
    if (!len)
      {
       _close(handle);
       return 0;
      }
    assert((*table = malloc(len)) != NULL);
    i = len / (MAXINT-1);
    do
      if (_read(handle, *table, MAXINT-1) == -1)
	{
	 printf("訡 ⥭ 䠩 %s!\n", name);
	 free(*table);
	 return 0;
	}
    while (i--);
    _close(handle);
    return len;
  } // load_table

//⮢ 室 䠩
void open_c(char *name)
  {if ((out = fopen(name,"w")) < 0)
    {
     printf("訡 ᮧ 䠩 '%s' !\n", name);
     abort();
    }
   //饭 맮 ⥪  室 䠩
   if (flag_stdio == 1)
     fprintf(out,"#include <stdio.h>\n");
   if (flag_stdlib == 1)
     fprintf(out,"#include <stdlib.h>\n");

   fprintf(out,"\n");
   fprintf(out,"void main(void)\n");
   fprintf(out,"  {\n");
  } // open_c

//⮢ ६ 䠩
void open_tmp(char *name)
  {if ((tmp = fopen(name,"w+")) < 0)
    {
     printf("訡 ᮧ 䠩 '%s' !\n", name);
     abort();
    }
  } // open_tmp

// ᫥饣 蠣
void nextstep(int opd,Operand tmp)
  {
    int i;
    unsigned char flag;
    flag = 0;
    for (i = opd-1;i >= 0 && flag == 0; i--)
     if (instr_tab[i].line != -1)
      switch (instr_tab[i].opcode)
	{
	 case addOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation1(i,"+");
	      flag = 1;
	      break;
	     }

	 case assOpc:
	   if (tmp.val.temp_num == instr_tab[i].arg2)
	     {
	      operation2(i,"");
	      flag = 1;
	      break;
	     }

	 case divOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation1(i,"/");
	      flag=1;
	      break;
	     }

	 case eqOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation1(i,"==");
	      flag = 1;
	      break;
	     }

	 case geOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation1(i,">=");
	      flag = 1;
	      break;
	     }

	 case gtOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation1(i,">");
	      flag = 1;
	      break;
	     }

	 case indexOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation3(i);
	      flag = 1;
	      break;
	     }

	 case leOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation1(i,"<=");
	      flag = 1;
	      break;
	     }

	 case ltOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation1(i,"<");
	      flag = 1;
	      break;
	     }

	 case minOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation2(i,"-");
	      flag = 1;
	      break;
	     }

	 case modOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation1(i,"%");
	      flag = 1;
	      break;
	     }

	 case multOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation1(i,"*");
	      flag = 1;
	      break;
	     }

	 case neOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation1(i,"!=");
	      flag = 1;
	      break;
	     }

	 case subOpc:
	   if (tmp.val.temp_num == instr_tab[i].rez)
	     {
	      operation1(i,"-");
	      flag = 1;
	      break;
	     }

	} // switch (instr_tab[i].opcode)
    if (flag == 0)
      error("Invalid operand");

  } // nextstep

//᭮ ணࠬ
void main(int arg_num, char *args[])
  {
    int tab_num, i;
    char *s, /*st = 34,*/ flag_counter;
    if (arg_num<2)
      {
	puts("Example: compil.exe <input_file>");
	exit(0);
      }

    //饭   ⠡
    //権, ६, ࠭  ⠭

    assert((name = malloc(strlen(args[1])+4)) != NULL);
    for (tab_num = 0; tab_num < 4; tab_num++)
      {
	strcpy(name, args[1]);
	strcat(name, exts[tab_num]);
	switch (tab_num)
	  {
	    case 0:
	      instr_num = load_table(name, (char**)&instr_tab) / sizeof(Instr);
	      break;

	    case 1:
	      ident_num = load_table(name, (char**)&ident_tab) / sizeof(Ident);
	      break;

	    case 2:
	      oper_num = load_table(name, (char**)&oper_tab) / sizeof(Operand);
	      break;

	    case 3:
	      const_num = load_table(name, (char**)&const_tab) / sizeof(Const);
	      break;
	  } // switch (tab_num)

      } // for(tab_num=0;tab_num < 4;tab_num++)
    free(name);

    //樠 ६ 䠩
    assert((name = malloc(strlen(args[1])+4)) != NULL);
    strcpy(name, args[1]);
    strcat(name, ".tmp");
    open_tmp(name);
    free(name);

    flag_counter = 0;
    flag_stdio = 0;
    flag_stdlib = 0;
    // ࠭樨
    for (i = instr_num-1;i >= 0; i--)
     if (instr_tab[i].line > -1)
      switch (instr_tab[i].opcode)
	{
	  Operand l_opd, r_opd, rez;
	  Ident l_id, r_id,rez_id;
	  Const c, l_const;

	  //᢮
	  case assOpc:
	    r_opd = oper_tab[instr_tab[i].arg1];
	    l_opd = oper_tab[instr_tab[i].arg2];

	    switch (l_opd.type)
	      {
		case nameVarOpd:
		  l_id = ident_tab[l_opd.val.ident_num];
		  fprintf(tmp,"%s = ",l_id.name);
		  switch (r_opd.type)
		    {
		      case tmpVarOpd:
			nextstep(i,r_opd);
			fprintf(tmp,";\n");
			break;
		      default:
			error("Invalid right operand in assign instruction");
			break;
		    } // switch (r_opd.type)
		  break;
		case indexVarOpd:
		case tmpVarOpd:
		  l_id = ident_tab[l_opd.val.temp_num];
		  nextstep(i,l_opd);
		  fprintf(tmp," = ");
		  switch (r_opd.type)
		    {
		      case tmpVarOpd:
		      case indexVarOpd:
			nextstep(i,r_opd);
			fprintf(tmp,";\n");
			break;
		      case nameVarOpd:
			fprintf(tmp,"%s;\n",ident_tab[r_opd.val.ident_num].name);
			break;
		      case constOpd:
			c = const_tab[r_opd.val.const_num];
			if (ident_tab[r_opd.val.const_num].type == float_type)
			  fprintf(tmp,"%f;\n",c.val.fnum);
			else
			  fprintf(tmp,"%d;\n",c.val.inum);
			break;
		      default:
			error("Invalid right operand in assign instruction");
			break;
		    } // switch (r_opd.type)
		  break;
	      } // switch (l_opd.type)
	    break;

	  // 樨
	  case emptyOpc:
	    break;

	  //室
	  case exitOpc:
	    fprintf(tmp,"exit(0);\n");
            flag_stdlib = 1;
	    break;

	  //᫮ 室
	  case gotoOpc:
	    l_opd = oper_tab[instr_tab[i].arg1];
	    if (l_opd.type != labelOpd)
	      error("Invalid operand type in instruction");
	    fprintf(tmp,"goto label%d;\n",l_opd.val.instr_num);
	    break;

	  //᫮ 室
	  case ifOpc:
	    l_opd = oper_tab[instr_tab[i].arg1];
	    r_opd = oper_tab[instr_tab[i].arg2];

	    if (l_opd.type != tmpVarOpd || r_opd.type != labelOpd)
	      error("Invalid operand type in instruction");
	    fprintf(tmp,"if (!(");
	    nextstep(i,l_opd);
	    fprintf(tmp,")) goto label%d;\n",r_opd.val.instr_num);
	    break;

	  //
	  case inOpc:
	    rez = oper_tab[instr_tab[i].arg1];
	    fprintf(tmp,"scanf (");

	    switch (rez.type)
	      {
		case nameVarOpd:
                  if (ident_tab[rez.val.ident_num].type == float_type)
                    fprintf(tmp,"%c%c%c%c,&",'"','%','f','"');
                  else
                    fprintf(tmp,"%c%c%c%c,&",'"','%','d','"');
		  fprintf(tmp,"%s);\n",ident_tab[rez.val.ident_num].name);
		  break;
                case tmpVarOpd:
		case indexVarOpd:
                  flag_float = 0;
                  fprintf(tmp,"%c%c%c%c,&",'"','%','d','"');
		  nextstep(i,rez);
		  fprintf(tmp,");");
                  if (flag_float == 1)
                    fprintf(tmp,"");
                  fprintf(tmp,"\n");
		  break;
		default:
		  error("Invalid right operand in assign instruction");
		  break;
	      } // switch (rez.type)
            flag_stdio = 1;
	    break;

	  //⪠
	  case labelOpc:
	    fprintf(tmp,"label%d:\n",i);
	    break;

	  //뢮
	  case outOpc:
	    rez = oper_tab[instr_tab[i].arg1];
	    fprintf(tmp,"printf(");

	    switch (rez.type)
	      {
		case nameVarOpd:
                  if (ident_tab[rez.val.ident_num].type == float_type)
                    fprintf(tmp,"%c%c%c%c,",'"','%','f','"');
                  else
                    fprintf(tmp,"%c%c%c%c,",'"','%','d','"');
		  fprintf(tmp,"%s);\n",ident_tab[rez.val.ident_num].name);
		  break;
		case tmpVarOpd:
		case indexVarOpd:
                  flag_float = 0;
                  fprintf(tmp,"%c%c%c%c,",'"','%','d','"');
		  nextstep(i,rez);
		  fprintf(tmp,");");
                  if (flag_float == 1)
                    fprintf(tmp,"");
                  fprintf(tmp,"\n");
		  break;
		case constOpd:
		  if (const_tab[rez.val.const_num].type == float_type)
		    fprintf(tmp,"%c%c%c%c,%f);\n",'"','%','f','"',const_tab[rez.val.const_num].val.fnum);
		  else
		    fprintf(tmp,"%c%c%c%c,%d);\n",'"','%','d','"',const_tab[rez.val.const_num].val.inum);
		  break;
		default:
		  error("Invalid right operand in assign instruction");
		  break;
	      } // switch (rez.type)
            flag_stdio = 1;
	    break;

	  //뢮 ஡  ࠭
	  case spaceOutOpc:
	    fprintf(tmp,"for (for_counter = 0;for_counter < ");
	    rez = oper_tab[instr_tab[i].arg1];
	    switch (rez.type)
	      {
		case nameVarOpd:
		  fprintf(tmp,"%s",ident_tab[rez.val.ident_num].name);
		  break;
		case tmpVarOpd:
		case indexVarOpd:
		  nextstep(i,rez);
		  break;
		case constOpd:
		  if (const_tab[rez.val.const_num].type == float_type)
		    fprintf(tmp,"%f",const_tab[rez.val.const_num].val.fnum);
		  else
		    fprintf(tmp,"%d",const_tab[rez.val.const_num].val.inum);
		  break;
		default:
		  error("Invalid right operand in assign instruction");
		  break;
	      } // switch (rez.type)

	    fprintf(tmp,"; for_counter++) printf(\" \");\n");
	    //fprintf(tmp,"; for_counter++) printf(%c %c);\n",st,st);
	    flag_counter = 1;
	    flag_stdio = 1;
	    break;

	  //뢮 ॢ ப  ࠭
	  case skipOutOpc:
	    fprintf(tmp,"for (for_counter = 0;for_counter < ");
	    rez = oper_tab[instr_tab[i].arg1];
	    switch (rez.type)
	      {
		case nameVarOpd:
		  fprintf(tmp,"%s",ident_tab[rez.val.ident_num].name);
		  break;
		case tmpVarOpd:
		case indexVarOpd:
		  nextstep(i,rez);
		  break;
		case constOpd:
		  if (const_tab[rez.val.const_num].type == float_type)
		    fprintf(tmp,"%f",const_tab[rez.val.const_num].val.fnum);
		  else
		    fprintf(tmp,"%d",const_tab[rez.val.const_num].val.inum);
		  break;
		default:
		  error("Invalid right operand in assign instruction");
		  break;
	      } // switch (rez.type)

	    fprintf(tmp,"; for_counter++) printf(\"\\n\");\n");
	    flag_counter = 1;
	    flag_stdio = 1;
	    break;

	  //뢮 TAB
	  case tabOutOpc:
	    fprintf(tmp,"for (for_counter = 0;for_counter <");
	    rez = oper_tab[instr_tab[i].arg1];
	    switch (rez.type)
	      {
		case nameVarOpd:
		  fprintf(tmp,"%s",ident_tab[rez.val.ident_num].name);
		  break;
		case tmpVarOpd:
		case indexVarOpd:
		  nextstep(i,rez);
		  break;
		case constOpd:
		  if (const_tab[rez.val.const_num].type == float_type)
		    fprintf(tmp,"%f",const_tab[rez.val.const_num].val.fnum);
		  else
		    fprintf(tmp,"%d",const_tab[rez.val.const_num].val.inum);
		  break;
		default:
		  error("Invalid right operand in assign instruction");
		  break;
	      } // switch (rez.type)

	    fprintf(tmp,"; for_counter++) printf(\"\\t\");\n");
	    //fprintf(tmp,"; for_counter++) printf(%c%c%c%c);\n",st,st+58,'t',st);
	    flag_counter = 1;
	    flag_stdio = 1;
	    break;

	  //訡
	  default:
	    error("Invalid code operation");

	} // switch (instr_tab[i].opcode)

    //樠 室 䠩
    assert((name = malloc(strlen(args[1])+4)) != NULL);
    strcpy(name, args[1]);
    strcat(name, ".c");
    open_c(name);
    free(name);

    //饭 ᪨ ६  室 䠩
    if (ident_tab[0].type == int_type)
      {
	fprintf(out,"    int %s",ident_tab[0].name);
	if (ident_tab[0].len>0)
	  fprintf(out,"[%d]",ident_tab[0].len);
      }
    else
      {
	fprintf(out,"    float %s",ident_tab[0].name);
	if (ident_tab[0].len>0)
	  fprintf(out,"[%d]",ident_tab[0].len);
      }
    for (i = 1;i < ident_num; i++)
      {
	if (ident_tab[i].type == int_type)
	  {
	    if (ident_tab[i].type == ident_tab[i-1].type)
	      fprintf(out,",%s",ident_tab[i].name);
	    else
	      fprintf(out,";\n    int %s",ident_tab[i].name);
	    if (ident_tab[i].len>0)
	      fprintf(out,"[%d]",ident_tab[i].len);
	  }
	else
	  {
	    if (ident_tab[i].type == ident_tab[i-1].type)
	      fprintf(out,",%s",ident_tab[i].name);
	    else
	      fprintf(out,";\n    float %s",ident_tab[i].name);
	    if (ident_tab[i].len>0)
	      fprintf(out,"[%d]",ident_tab[i].len);
	 }
      } // for (i = 1;i < ident_num; i++)

    if (flag_counter == 1)
      fprintf(out,";\n    int for_counter");
    fprintf(out,";\n");

    convert();

    fprintf(out,"  }\n");

    fclose(out);
    fclose(tmp);

    free(instr_tab);
    free(ident_tab);
    free(oper_tab);
    free(const_tab);

    assert((name = malloc(strlen(args[1])+4)) != NULL);
    strcpy(name, args[1]);
    strcat(name, ".tmp");
    remove(name);
    free(name);

   } // main