
// Name: compil.h
// 21.09.96


 #ifndef _COMPIL_H
 #define _COMPIL_H

 #include <stdio.h>
 #include <stdlib.h>
 #include <conio.h>

 typedef enum
   {
     addOpc,       assOpc,         divOpc,         eqOpc,
     emptyOpc,     exitOpc,        geOpc,          gotoOpc,
     gtOpc,        ifOpc,          inOpc,          indexOpc,
     labelOpc,     leOpc,          ltOpc,          minOpc,
     modOpc,       multOpc,        neOpc,          outOpc,
     skipOutOpc,   spaceOutOpc,    subOpc,         tabOutOpc
   }
 opcType;

 typedef enum
   {
     int_type,
     float_type
   }
 scalType;


 typedef enum
   {
     nameVarOpd, //  ६  ⠡ 
     tmpVarOpd,  // ஬筠 ६  ࠦ
     constOpd,   // ⠭ ࠭
     labelOpd,    // ࠭ - ⪠
     indexVarOpd  // ஢ ६
   }
 opdType;

 #include "transl.h"

 typedef struct Ident
   {
     char     name[name_len];  //  ६
     scalType type;            // ᪠ ⨯ ६
     int      len;             //   ( = 0, ᫨ ᪠)
     int      addr;            //   䨧᪮ 
   }
 Ident;

 typedef struct Operand
   {
     opdType type;        // ⨯ ࠭
     union
       {
	 int temp_num;
	 int ident_num;
	 int const_num;
	 int instr_num;
       }
     val;
   }
 Operand;

 typedef struct Const
   {
     scalType type;      // ⨯ ⠭
     union
       {
	 int   inum;    // 楫 ⠭
	 float fnum;    // ⢨⥫쭠 ⠭
       }
     val;
   }
 Const;

 typedef struct Temp
   {
     int          id;              //  ६
     scalType     type;            // ᪠ ⨯ ६
     int          len;             //   ( = 0, ᫨ ᪠)
     int          addr;            //   ⥪
   }
 Temp;



 extern Instr   *instr_tab;
 extern int     instr_num;

 extern Ident   *ident_tab;
 extern int     ident_num;

 extern Operand *oper_tab;
 extern int     oper_num;

 extern Const   *const_tab;
 extern int     const_num;
 extern FILE    *tmp,*out;
 extern char    flag_float;


void operation1(int i,char *s);
void operation2(int i,char *s);
void operation3(int i);
void nextstep(int i,Operand opd);
void convert(void);

 #define error(str) \
   printf("\nError in line %d: %s !\n",instr_tab[i].line, str),\
   free(instr_tab),free(ident_tab),free(oper_tab),free(const_tab),abort();


 #endif